OGRE: Ogre::SubEntity Class Reference - OGRE Documentation

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Friends

# Ogre::SubEntity Class Reference
[Scene]

Utility class which defines the sub-parts of an Entity. More...

`#include <OgreSubEntity.h>`

Inheritance diagram for Ogre::SubEntity:
[legend]

List of all members.

## Public Member Functions
const String & | getMaterialName () const
| Gets the name of the Material in use by this instance.
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the Material to be used.
void | setMaterial (const MaterialPtr &material)
| Sets a Material to be used.
virtual void | setVisible (bool visible)
| Tells this SubEntity whether to be visible or not.
virtual bool | isVisible (void) const
| Returns whether or not this SubEntity is supposed to be visible.
SubMesh * | getSubMesh (void)
| Accessor method to read mesh data.
Entity * | getParent (void) const
| Accessor to get parent Entity.
const MaterialPtr & | getMaterial (void) const
| Overridden - see Renderable.
Technique * | getTechnique (void) const
| Overridden - see Renderable.
void | getRenderOperation (RenderOperation &op)
| Overridden - see Renderable.
void | getWorldTransforms (Matrix4 *xform) const
| Overridden - see Renderable.
unsigned short | getNumWorldTransforms (void) const
| Overridden - see Renderable.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable.
const LightList & | getLights (void) const
bool | getCastsShadows (void) const
VertexData * | _getSkelAnimVertexData (void)
| Advanced method to get the temporarily blended vertex information for entities which are software skinned.
VertexData * | _getSoftwareVertexAnimVertexData (void)
| Advanced method to get the temporarily blended software morph vertex information.
VertexData * | _getHardwareVertexAnimVertexData (void)
| Advanced method to get the hardware morph vertex information.
TempBlendedBufferInfo * | _getSkelAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software skeletal animation.
TempBlendedBufferInfo * | _getVertexAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software morph animation.
VertexData * | getVertexDataForBinding (void)
| Retrieve the VertexData which should be used for GPU binding.
void | _markBuffersUnusedForAnimation (void)
| Mark all vertex data as so far unanimated.
void | _markBuffersUsedForAnimation (void)
| Mark all vertex data as animated.
bool | _getBuffersMarkedForAnimation (void) const
| Are buffers already marked as vertex animated?
void | _restoreBuffersForUnusedAnimation (bool hardwareAnimation)
| Internal method to copy original vertex data to the morph structures should there be no active animation in use.
void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Overridden from Renderable to provide some custom behaviour.
void | _invalidateCameraCache ()
| Invalidate the camera distance cache.
virtual const MaterialPtr & | getMaterial (void) const =0
| Retrieves a weak reference to the material this renderable object uses.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual void | getRenderOperation (RenderOperation &op)=0
| Gets the render operation required to send this object to the frame buffer.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual void | getWorldTransforms (Matrix4 *xform) const =0
| Gets the world transform matrix / matrices for this renderable object.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual Real | getSquaredViewDepth (const Camera *cam) const =0
| Returns the camera-relative squared depth of this renderable.
virtual const LightList & | getLights (void) const =0
| Gets a list of lights, ordered relative to how close they are to this renderable.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual void | setUserAny (const Any &anything)
virtual const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
virtual RenderSystemData * | getRenderSystemData () const
| Sets render system private data.
virtual void | setRenderSystemData (RenderSystemData *val) const
| gets render system private data
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef map< size_t, Vector4 > ::type | CustomParameterMap
## Protected Member Functions
| SubEntity (Entity *parent, SubMesh *subMeshBasis)
| Private constructor - don't allow creation by anybody else.
virtual | ~SubEntity ()
| Private destructor.
void | prepareTempBlendBuffers (void)
| Internal method for preparing this Entity for use in animation.
## Protected Attributes
Entity * | mParentEntity
| Pointer to parent.
String | mMaterialName
| Name of Material in use by this SubEntity.
MaterialPtr | mpMaterial
| Cached pointer to material.
SubMesh * | mSubMesh
bool | mVisible
| Is this SubEntity visible?
unsigned short | mMaterialLodIndex
| The LOD number of the material to use, calculated by Entity::_notifyCurrentCamera.
VertexData * | mSkelAnimVertexData
| blend buffer details for dedicated geometry
TempBlendedBufferInfo | mTempSkelAnimInfo
| Quick lookup of buffers.
TempBlendedBufferInfo | mTempVertexAnimInfo
| Temp buffer details for software Vertex anim geometry.
VertexData * | mSoftwareVertexAnimVertexData
| Vertex data details for software Vertex anim of shared geometry.
VertexData * | mHardwareVertexAnimVertexData
| Vertex data details for hardware Vertex anim of shared geometry separate since we need to s/w anim for shadows whilst still altering the vertex data for hardware morphing (pos2 binding).
bool | mVertexAnimationAppliedThisFrame
| Have we applied any vertex animation to geometry?
ushort | mHardwarePoseCount
| Number of hardware blended poses supported by material.
Real | mCachedCameraDist
| Cached distance to last camera for getSquaredViewDepth.
const Camera * | mCachedCamera
| The camera for which the cached distance is valid.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
UserObjectBindings | mUserObjectBindings
RenderSystemData * | mRenderSystemData
## Friends
class | Entity
class | SceneManager

## Detailed Description

Utility class which defines the sub-parts of an Entity.

Remarks:
  Just as meshes are split into submeshes, an Entity is made up of potentially multiple SubMeshes. These are mainly here to provide the link between the Material which the SubEntity uses (which may be the default Material for the SubMesh or may have been changed for this object) and the SubMesh data.

  The SubEntity also allows the application some flexibility in the material properties for this section of a particular instance of this Mesh, e.g. tinting the windows on a car model.

  SubEntity instances are never created manually. They are created at the same time as their parent Entity by the SceneManager method createEntity.

Definition at line 62 of file OgreSubEntity.h.

## Member Typedef Documentation

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap`[protected, inherited]`

Definition at line 395 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::SubEntity::SubEntity | ( | Entity * | parent,
|  | SubMesh * | subMeshBasis |
| ) |  |  | `[protected]`

Private constructor - don't allow creation by anybody else.

virtual Ogre::SubEntity::~SubEntity | ( |  | ) | `[protected, virtual]`

Private destructor.

## Member Function Documentation

bool Ogre::SubEntity::_getBuffersMarkedForAnimation | ( | void |  | ) | const

Are buffers already marked as vertex animated?

Definition at line 218 of file OgreSubEntity.h.

VertexData* Ogre::SubEntity::_getHardwareVertexAnimVertexData | ( | void |  | ) |

Advanced method to get the hardware morph vertex information.

Note:
  The positions/normals of the returned vertex data is in object space.

TempBlendedBufferInfo* Ogre::SubEntity::_getSkelAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software skeletal animation.

VertexData* Ogre::SubEntity::_getSkelAnimVertexData | ( | void |  | ) |

Advanced method to get the temporarily blended vertex information for entities which are software skinned.

Remarks:
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via Entity::addSoftwareAnimationRequest.

Note:
  The positions/normals of the returned vertex data is in object space.

VertexData* Ogre::SubEntity::_getSoftwareVertexAnimVertexData | ( | void |  | ) |

Advanced method to get the temporarily blended software morph vertex information.

Remarks:
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via Entity::addSoftwareAnimationRequest.

Note:
  The positions/normals of the returned vertex data is in object space.

TempBlendedBufferInfo* Ogre::SubEntity::_getVertexAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software morph animation.

void Ogre::SubEntity::_invalidateCameraCache | ( |  | ) |

Invalidate the camera distance cache.

Definition at line 230 of file OgreSubEntity.h.

void Ogre::SubEntity::_markBuffersUnusedForAnimation | ( | void |  | ) |

Mark all vertex data as so far unanimated.

void Ogre::SubEntity::_markBuffersUsedForAnimation | ( | void |  | ) |

Mark all vertex data as animated.

void Ogre::SubEntity::_restoreBuffersForUnusedAnimation | ( | bool | hardwareAnimation | ) |

Internal method to copy original vertex data to the morph structures should there be no active animation in use.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Definition at line 288 of file OgreRenderable.h.

References Ogre::GpuProgramParameters::_writeRawConstant(), Ogre::GpuProgramParameters::AutoConstantEntry::data, Ogre::GpuProgramParameters::AutoConstantEntry::elementCount, and Ogre::GpuProgramParameters::AutoConstantEntry::physicalIndex.

void Ogre::SubEntity::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const

Overridden from Renderable to provide some custom behaviour.

bool Ogre::SubEntity::getCastsShadows | ( | void |  | ) | const

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 223 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 249 of file OgreRenderable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

const LightList& Ogre::SubEntity::getLights | ( | void |  | ) | const

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

virtual const LightList& Ogre::Renderable::getLights | ( | void |  | ) | const`[pure virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SimpleRenderable.

const MaterialPtr& Ogre::SubEntity::getMaterial | ( | void |  | ) | const

Overridden - see Renderable.

virtual const MaterialPtr& Ogre::Renderable::getMaterial | ( | void |  | ) | const`[pure virtual, inherited]`

Retrieves a weak reference to the material this renderable object uses.

Remarks:
  Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SimpleRenderable.

const String& Ogre::SubEntity::getMaterialName | ( |  | ) | const

Gets the name of the Material in use by this instance.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 152 of file OgreRenderable.h.

unsigned short Ogre::SubEntity::getNumWorldTransforms | ( | void |  | ) | const

Overridden - see Renderable.

Entity* Ogre::SubEntity::getParent | ( | void |  | ) | const

Accessor to get parent Entity.

Definition at line 150 of file OgreSubEntity.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Definition at line 313 of file OgreRenderable.h.

void Ogre::SubEntity::getRenderOperation | ( | RenderOperation & | op | ) |

Overridden - see Renderable.

virtual void Ogre::Renderable::getRenderOperation | ( | RenderOperation & | op | ) | `[pure virtual, inherited]`

Gets the render operation required to send this object to the frame buffer.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, and Ogre::SimpleRenderable.

virtual RenderSystemData* Ogre::Renderable::getRenderSystemData | ( |  | ) | const`[virtual, inherited]`

Sets render system private data.

Remarks:
  This should only be used by a render system

Definition at line 380 of file OgreRenderable.h.

virtual Real Ogre::Renderable::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[pure virtual, inherited]`

Returns the camera-relative squared depth of this renderable.

Remarks:
  Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, Ogre::Rectangle2D, and Ogre::WireBoundingBox.

Referenced by Ogre::QueuedRenderableCollection::RadixSortFunctorDistance::operator()(), and Ogre::QueuedRenderableCollection::DepthSortDescendingLess::operator()().

Real Ogre::SubEntity::getSquaredViewDepth | ( | const Camera * | cam | ) | const

Overridden, see Renderable.

SubMesh* Ogre::SubEntity::getSubMesh | ( | void |  | ) |

Accessor method to read mesh data.

Technique* Ogre::SubEntity::getTechnique | ( | void |  | ) | const

Overridden - see Renderable.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket.

Definition at line 93 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 177 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 202 of file OgreRenderable.h.

virtual const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

Retrieves the custom user value associated with this object.

Definition at line 330 of file OgreRenderable.h.

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const`[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 342 of file OgreRenderable.h.

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | `[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 336 of file OgreRenderable.h.

VertexData* Ogre::SubEntity::getVertexDataForBinding | ( | void |  | ) |

Retrieve the VertexData which should be used for GPU binding.

virtual void Ogre::Renderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[pure virtual, inherited]`

Gets the world transform matrix / matrices for this renderable object.

Remarks:
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note:
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also:
  Matrix4::isAffine.

Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::SimpleRenderable, and Ogre::WireBoundingBox.

void Ogre::SubEntity::getWorldTransforms | ( | Matrix4 * | xform | ) | const

Overridden - see Renderable.

virtual bool Ogre::SubEntity::isVisible | ( | void |  | ) | const`[virtual]`

Returns whether or not this SubEntity is supposed to be visible.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called immediately after the Renderable has been rendered.

Definition at line 127 of file OgreRenderable.h.

void Ogre::SubEntity::prepareTempBlendBuffers | ( | void |  | ) | `[protected]`

Internal method for preparing this Entity for use in animation.

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called just prior to the Renderable being rendered.

Remarks:
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns:
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value |
| ) |  |  | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 240 of file OgreRenderable.h.

void Ogre::SubEntity::setMaterial | ( | const MaterialPtr & | material | ) |

Sets a Material to be used.

Remarks:
  By default a SubEntity uses the default Material that the SubMesh uses. This call can alter that so that the Material is different for this instance.

void Ogre::SubEntity::setMaterialName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME` |
| ) |  |  |

Sets the name of the Material to be used.

Remarks:
  By default a SubEntity uses the default Material that the SubMesh uses. This call can alter that so that the Material is different for this instance.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 305 of file OgreRenderable.h.

virtual void Ogre::Renderable::setRenderSystemData | ( | RenderSystemData * | val | ) | const`[virtual, inherited]`

gets render system private data

Remarks:
  This should only be used by a render system

Definition at line 388 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 163 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 188 of file OgreRenderable.h.

virtual void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

Definition at line 325 of file OgreRenderable.h.

virtual void Ogre::SubEntity::setVisible | ( | bool | visible | ) | `[virtual]`

Tells this SubEntity whether to be visible or not.

## Friends And Related Function Documentation

friend class Entity`[friend]`

Definition at line 65 of file OgreSubEntity.h.

friend class SceneManager`[friend]`

Definition at line 66 of file OgreSubEntity.h.

## Member Data Documentation

const Camera* Ogre::SubEntity::mCachedCamera`[mutable, protected]`

The camera for which the cached distance is valid.

Definition at line 113 of file OgreSubEntity.h.

Real Ogre::SubEntity::mCachedCameraDist`[mutable, protected]`

Cached distance to last camera for getSquaredViewDepth.

Definition at line 111 of file OgreSubEntity.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

Definition at line 396 of file OgreRenderable.h.

ushort Ogre::SubEntity::mHardwarePoseCount`[protected]`

Number of hardware blended poses supported by material.

Definition at line 109 of file OgreSubEntity.h.

VertexData* Ogre::SubEntity::mHardwareVertexAnimVertexData`[protected]`

Vertex data details for hardware Vertex anim of shared geometry

- separate since we need to s/w anim for shadows whilst still altering the vertex data for hardware morphing (pos2 binding).

Definition at line 105 of file OgreSubEntity.h.

unsigned short Ogre::SubEntity::mMaterialLodIndex`[protected]`

The LOD number of the material to use, calculated by Entity::_notifyCurrentCamera.

Definition at line 92 of file OgreSubEntity.h.

String Ogre::SubEntity::mMaterialName`[protected]`

Name of Material in use by this SubEntity.

Definition at line 80 of file OgreSubEntity.h.

Entity* Ogre::SubEntity::mParentEntity`[protected]`

Pointer to parent.

Definition at line 77 of file OgreSubEntity.h.

MaterialPtr Ogre::SubEntity::mpMaterial`[protected]`

Cached pointer to material.

Definition at line 83 of file OgreSubEntity.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

Definition at line 397 of file OgreRenderable.h.

RenderSystemData* Ogre::Renderable::mRenderSystemData`[mutable, protected, inherited]`

Definition at line 401 of file OgreRenderable.h.

VertexData* Ogre::SubEntity::mSkelAnimVertexData`[protected]`

blend buffer details for dedicated geometry

Definition at line 95 of file OgreSubEntity.h.

VertexData* Ogre::SubEntity::mSoftwareVertexAnimVertexData`[protected]`

Vertex data details for software Vertex anim of shared geometry.

Definition at line 101 of file OgreSubEntity.h.

SubMesh* Ogre::SubEntity::mSubMesh`[protected]`

Definition at line 86 of file OgreSubEntity.h.

TempBlendedBufferInfo Ogre::SubEntity::mTempSkelAnimInfo`[protected]`

Quick lookup of buffers.

Definition at line 97 of file OgreSubEntity.h.

TempBlendedBufferInfo Ogre::SubEntity::mTempVertexAnimInfo`[protected]`

Temp buffer details for software Vertex anim geometry.

Definition at line 99 of file OgreSubEntity.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

Definition at line 398 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

Definition at line 399 of file OgreRenderable.h.

UserObjectBindings Ogre::Renderable::mUserObjectBindings`[protected, inherited]`

Definition at line 400 of file OgreRenderable.h.

bool Ogre::SubEntity::mVertexAnimationAppliedThisFrame`[protected]`

Have we applied any vertex animation to geometry?

Definition at line 107 of file OgreSubEntity.h.

bool Ogre::SubEntity::mVisible`[protected]`

Is this SubEntity visible?

Definition at line 89 of file OgreSubEntity.h.

The documentation for this class was generated from the following file:

- OgreSubEntity.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:02